#include <allegro.h>
#include <nas.h>
#include <nas_amp.h>

static void print_line(BITMAP *buffer, FONT *font, int x, int *y, int col, const char *s, ...);

int main(int argc, char **argv){
	NAS_WIDGET *browser;
	BITMAP *bg;
	int texty = 0;
	int key_hit = 0;
	int key_hit2 = 0;
   	allegro_init(); 
   	install_keyboard();
	install_timer();
	install_mouse();
	set_config_file("test.cfg");
	load_video_settings();
	set_video_settings();	
	bg = load_bitmap("images/allegro640x480.bmp", NULL);
	set_display_switch_mode(SWITCH_BACKGROUND);
    	init_nas();	
	init_amp();
	browser = nas_theme_select(100, 100, 400, 300);
	stretch_blit(bg, buffer, 0, 0, bg->w, bg->h, 0, 0, SCREEN_W, SCREEN_H);
	print_line(buffer, font, 0, &texty, makecol(255, 255, 255), "F1 - NAS Amp");
	print_line(buffer, font, 0, &texty, makecol(255, 255, 255), "F2 - Theme Browser");
	nasmouse_show_mouse(buffer);
	update_screen();
   	do{
		if(key[KEY_F1] && key_hit == 0){
			nas_init_dialog(nas_amp, NULL);
			key_hit = 1;
		}
		if(!key[KEY_F1] && key_hit == 1)
			key_hit = 0;
		if(key[KEY_F2] && key_hit2 == 0){
			nas_init_dialog(browser, NULL);
			key_hit2 = 1;
		}
		if(!key[KEY_F2] && key_hit2 == 1)
			key_hit2 = 0;
		nas_update_gui();
	}while(!key[KEY_ESC]);
	printf("here\n");
	nas_destroy_dialog(browser);
	amp_exit();
	nasmouse_show_mouse(NULL);
	save_video_settings();
   	video_exit();
	nas_exit();
	destroy_bitmap(bg);
   	return 0; 
} 
END_OF_MAIN();

static void print_line(BITMAP *buffer, FONT *font, int x, int *y, int col, const char *s, ...){
	va_list ap;
	char buf[1024];
	va_start(ap, s);
        vsprintf(buf, s, ap);
        va_end(ap);
	textout(buffer, font, buf, x, *y, col);
	*y = *y + text_height(font);
}
