/*	    _   __ ___    _____    ______ __  __ ____
   	   / | / //   |  / ___/   / ____// / / //  _/
  	  /  |/ // /| |  \__ \   / / __ / / / / / /
 	 / /|  // ___ | ___/ /  / /_/ // /_/ /_/ /
	/_/ |_//_/  |_|/____/   \____/ \____//___/
			Not Another Skinnable GUI

	NAS AMP Media Player by Steve Terry
	June 28, 2003
*/

#ifndef NAS_AMP_H
#define NAS_AMP_H

#include <allegro.h>
#include <fmod.h>
#include <fmod_errors.h>
#include <nas.h>
#include "id3.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __MINGW32__
	#define snprintf _snprintf
#endif

#define AMP_OSS        	 	(D_USER) 
#define AMP_FIRE    		(D_USER * 2) 
#define AMP_LINE    		(D_USER * 4) 
#define AMP_PEAKS   		(D_USER * 8)

#define AMP_DIALOG_FLAGS 	(D_EXIT | D_MOVABLE | D_MINIMIZE | D_SEPARATOR)
#define AMP_BUTTON_FLAGS 	(D_DEFAULT_W | D_DEFAULT_H)
#define AMP_DEFLT_FLAGS  	(D_DEFAULT_W | D_DEFAULT_H)
#define AMP_SPECT_FLAGS  	(AMP_PEAKS | AMP_FIRE)

#define AMP_DEFAULT_BUFFER 	100
#define AMP_DEFAULT_FREQ	22050
#define AMP_DEFAULT_CHAN	64

// Actual API functions
extern NAS_WIDGET *nas_amp;

int init_amp();
void amp_exit();

#ifdef __cplusplus
}
#endif

#endif
