/*	    _   __ ___    _____    ______ __  __ ____
   	   / | / //   |  / ___/   / ____// / / //  _/
  	  /  |/ // /| |  \__ \   / / __ / / / / / /
 	 / /|  // ___ | ___/ /  / /_/ // /_/ /_/ /
	/_/ |_//_/  |_|/____/   \____/ \____//___/
			Not Another Skinnable GUI

	MP3 ID3v1 Tag Reader by Steve Terry
	June 28, 2003
*/

#include "id3.h"

static int testForTag (FILE *fmp3);

char *getartist(char *fname){
	static char buffer[256];
	char *ptr = fname;
	int i = 0;
	int l = 0;
	while(*ptr != '\0'){
		if(*ptr == '-')
			l = i;
		else if(*ptr == '.' && l == 0)
			l = i;	
		ptr++;
		i++;
	}
	if(l != 0){
		ptr = (fname + l - 1);
		while(*ptr == ' ' || *ptr == '-'){
			ptr--;
			l--;
		}
	}
	if(l > 29)
		l = 29;
	ptr = fname;
	i = 0;
	while(i < l){
		if(*ptr == '_')
			buffer[i] = ' ';
		else
			buffer[i] = *ptr;
		i++;
		ptr++;
	}
	buffer[i] = '\0';
	return buffer;
}

char *gettitle(char *fname){
	static char buffer[256];
	char *ptr = fname;
	int i = 0;
	int l = 0;
	while(*ptr != '\0'){
		if(*ptr == '-')
			l = i;
		else if(*ptr == '.' && l == 0)
			l = i;	
		ptr++;
		i++;
	}
	ptr = (fname + l);
	while(*ptr == ' ' || *ptr == '-')
		ptr++;
		
	i = 0;
	while(*ptr != '\0' && *ptr != '.' && i < 29){
		if(*ptr == '_')
			buffer[i] = ' ';
		else
			buffer[i] = *ptr;
		ptr++;
		i++;
	}
	buffer[i] = '\0';
	return buffer;
}

static int testForTag (FILE *fmp3){
	char strtest[4];
	fseek(fmp3, -128, 2);
	fgets(strtest, 4, fmp3);
	if ((strtest[0] == 'T') && (strtest[1] == 'A') && (strtest[2] == 'G'))
		return 1;
	return 0;
}

void getTag(FILE *fmp3, ID3Tag *tag){
	char *ptr;
	if(testForTag(fmp3) == 0){
		tag->Title[0] = '\0';
		tag->Artist[0] = '\0';
		tag->Album[0] = '\0';
		strcpy(tag->Year, "????");
		tag->Comment[0] = '\0';
		tag->Genre_idx = 0;
		return;
	}
	fseek(fmp3, -125, SEEK_END);
	fgets(tag->Title, 30, fmp3);
	if(*tag->Title == '\0')
		strcpy(tag->Title, "Unknown Title");
	ptr = (tag->Title + strlen(tag->Title) - 1);
	while(*ptr == ' ')
		ptr--;
	*(++ptr) = '\0';
	fseek(fmp3, -95, SEEK_END);
	fgets(tag->Artist, 30, fmp3);
	if(*tag->Artist == '\0')
		strcpy(tag->Artist, "Unknown Artist");
	ptr = (tag->Artist + strlen(tag->Artist) - 1);
	while(*ptr == ' ')
		ptr--;
	*(++ptr) = '\0';
	fseek(fmp3, -65, SEEK_END);
	fgets(tag->Album, 30, fmp3);
	if(*tag->Album == '\0')
		strcpy(tag->Album, "Unknown Album");
	ptr = (tag->Album + strlen(tag->Album) - 1);
	while(*ptr == ' ')
		ptr--;
	*(++ptr) = '\0';
	fseek(fmp3, -35, SEEK_END);
	fgets(tag->Year, 5, fmp3);
	if(*tag->Year == '\0')
		strcpy(tag->Year, "????");
	fseek(fmp3, -31, SEEK_END);
	fgets(tag->Comment, 30, fmp3);
	fseek(fmp3, -1, SEEK_END);
	tag->Genre_idx = fgetc(fmp3);
	if(tag->Genre_idx > 147)
		tag->Genre_idx = 0;
	else
		tag->Genre_idx += 1;
}
